"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _resolve = _interopRequireDefault(require("resolve"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var isMatchedRequireCall = function isMatchedRequireCall(node, state) {
  var re = new RegExp(state.opts.matchPattern, 'g');
  return t.isIdentifier(node.callee, {
    name: 'require'
  }) && t.isLiteral(node.arguments[0]) && !t.isTemplateLiteral(node.arguments[0]) && node.arguments[0].value.match(re);
};

var readJSON = function readJSON(node, state) {
  var srcPath = _path["default"].resolve(state.file.opts.filename);

  var requireText = node.arguments[0].value;

  var jsonPath = _path["default"].join(srcPath, '..', requireText);

  var json = null;

  if (_fs["default"].existsSync(jsonPath + '.json')) {
    json = require(jsonPath);
  } else {
    var file = _resolve["default"].sync(requireText, {
      basedir: _path["default"].dirname(srcPath)
    });

    if (_fs["default"].existsSync(file)) {
      var fileText = _fs["default"].readFileSync(file, 'utf8');

      try {
        json = JSON.parse(fileText);
      } catch (e) {// if unable to JSON.parse, not a JSON file, so, ignore and move on
      }
    }
  }

  return json;
};

var replacePath = function replacePath(path, value) {
  path.replaceWith(t.expressionStatement(t.valueToNode(value)));
};

function _default() {
  return {
    visitor: {
      CallExpression: function CallExpression(path, state) {
        var node = path.node;

        if (isMatchedRequireCall(node, state)) {
          var json = readJSON(node, state);

          if (json) {
            replacePath(path, json);
          }
        }
      },
      MemberExpression: function MemberExpression(path, state) {
        var node = path.node;

        if (isMatchedRequireCall(node.object, state)) {
          var json = readJSON(node.object, state);

          if (json) {
            replacePath(path, json[node.property.name]);
          }
        }
      }
    }
  };
}